---
title: Video player styling basics
slug: Web/Guide/Audio_and_video_delivery/Video_player_styling_basics
tags:
  - Apps
  - Guide
  - Media
  - Styling
  - Video
---
<div class="summary">
<p><span class="seoSummary">In the previous <a href="https://developer.mozilla.org/en-US/Apps/Build/Manipulating_media/cross_browser_video_player">Cross browser video player article</a> we described how to build a cross-browser HTML5 video player using the Media and Fullscreen APIs. This follow-up article looks at how to style this custom player, including making it responsive.</span></p>
</div>

<h2 id="The_example_in_action">The example in action</h2>

<p><img alt="A video player with play, stop, volume and fullscreen controls, showing an image of a soldier." src="https://mdn.mozillademos.org/files/7729/video-player-styled.png" style="display: block; height: 297px; margin: 0px auto; width: 600px;"></p>

<p>You can find the code for the <a href="https://github.com/iandevlin/iandevlin.github.io/tree/master/mdn/video-player-styled">updated, styled example</a> on Github, and <a href="https://iandevlin.github.io/mdn/video-player-styled/">view it live</a>.</p>

<h2 id="Preliminary_modifications_from_the_original_example">Preliminary modifications from the original example</h2>

<p>This section summarises the modifications that were made to the <a href="https://github.com/iandevlin/iandevlin.github.io/tree/master/mdn/video-player">original video player example</a> to make the styling task easier, before the bulk of the work was started.</p>

<h3 id="HTML_Markup">HTML Markup</h3>

<p>There are a few changes that were made to the HTML markup shown in the previous article. The custom video controls and {{htmlelement("progress")}} element are now contained within {{htmlelement("div") }} elements, rather than residing inside unordered list items.</p>

<p>The markup for the custom controls now looks as follows:</p>

<pre class="brush: html">&lt;div id="video-controls" class="controls" data-state="hidden"&gt;
   &lt;button id="playpause" type="button" data-state="play"&gt;Play/Pause&lt;/button&gt;
   &lt;button id="stop" type="button" data-state="stop"&gt;Stop&lt;/button&gt;
   &lt;div class="progress"&gt;
      &lt;progress id="progress" value="0" min="0"&gt;
         &lt;span id="progress-bar"&gt;&lt;/span&gt;
      &lt;/progress&gt;
   &lt;/div&gt;
   &lt;button id="mute" type="button" data-state="mute"&gt;Mute/Unmute&lt;/button&gt;
   &lt;button id="volinc" type="button" data-state="volup"&gt;Vol+&lt;/button&gt;
   &lt;button id="voldec" type="button" data-state="voldown"&gt;Vol-&lt;/button&gt;
   &lt;button id="fs" type="button" data-state="go-fullscreen"&gt;Fullscreen&lt;/button&gt;
&lt;/div&gt;</pre>

<h3 id="Related_CSS_alteration">Related CSS alteration</h3>

<p>The previous article set the <code>display</code> property of the video controls to <code>block</code> in order to display them. This has now been changed to use a <a href="http://toddmotto.com/stop-toggling-classes-with-js-use-behaviour-driven-dom-manipulation-with-data-states/"><code>data-state</code> attribute</a>, which this code already uses to handle its <a href="https://developer.mozilla.org/en-US/Apps/Build/Manipulating_media/cross_browser_video_player#Fullscreen">fullscreen implementation</a>.</p>

<p>This "data-state" idea is also used for setting the current state of buttons within the video control set, which allows specific state styling.</p>

<h3 id="JavaScript">JavaScript</h3>

<p>As mentioned above, a <code>data-state</code> attribute is used in various places for styling purposes and these are set using JavaScript. Specific implementations will be mentioned at appropriate places below.</p>

<h2 id="Styling">Styling</h2>

<p>The resultant video player style used here is rather basic — this is intentional, as the purpose is to show how such a video player could be styled and be made responsive.</p>

<div class="note">
<p><strong>Note</strong>: in some cases some basic CSS is omitted from the code examples here as its use is either obvious or not specifically relevant to styling the video player.</p>
</div>

<h3 id="Basic_styling">Basic styling</h3>

<p>The HTML video and its controls are all contained within a {{htmlelement("figure") }} element, which is given a maximum width and height (based on the dimensions of the video used) and centered within the page:</p>

<pre class="brush: css">figure {
   max-width:64rem;
   width:100%;
   max-height:30.875rem;
   height:100%;
   margin:1.25rem auto;
   padding:1.051%;
   background-color:#666;
}</pre>

<p>The video controls container itself also needs some styling so that it is set up the correct way:</p>

<pre class="brush: css">.controls {
   width:100%;
   height:8.0971659919028340080971659919028%; /* of figure's height */
   position:relative;
}</pre>

<p>The height of the <code>.controls</code> class is set to be (a very precise!) percentage of the enclosing {{htmlelement("figure") }} element (this was worked out with experimentation based on the required button height). Its position is also specifically set to <code>relative</code>, which is required for its responsiveness (more on that later).</p>

<p>As mentioned earlier, a <code>data-state</code> attribute is now used to indicate whether the video controls are visible or not and these also need to be styled:</p>

<pre class="brush: css">.controls[data-state=hidden] {
   display:none;
}

.controls[data-state=visible] {
   display:block;
}</pre>

<p>There are a number of properties that also need to be set for all elements within the video controls:</p>

<pre class="brush: css">.controls &gt; * {
   float:left;
   width:3.90625%;
   height:100%;
   margin-left:0.1953125%;
   display:block;
}

.controls &gt; *:first-child {
   margin-left:0;
}</pre>

<p>All elements are floated left, as they are to be aligned next to one another, and each element is set to have a <code>width</code> of nearly 4% (again the actual value was calculated based on the required dimensions of the buttons), and a <code>height</code> of 100%. A value for <code>margin-left</code> is also set, but the first element (in this case the play/pause button) has this property overridden by the value 0.<br>
 <br>
 The {{htmlelement("div") }} container for the {{htmlelement("progress") }} element also requires some specific settings; it is set to be much wider than the other child elements and its cursor value is set to be pointer:</p>

<pre class="brush: css">.controls .progress {
   cursor:pointer;
   width:75.390625%;
}</pre>

<h3 id="Buttons">Buttons</h3>

<p>The first major styling task to tackle is to make the video control's buttons actually look like and act like real buttons.</p>

<p>Each button has some basic styling:</p>

<pre class="brush: css">.controls button {
   border:none;
   cursor:pointer;
   background:transparent;
   background-size:contain;
   background-repeat:no-repeat;
}</pre>

<p>By default, all {{htmlelement("button") }} elements have a border, so this is removed. Since background images will be used to display appropriate icons, the background colour of the button is set to be transparent, non-repeated, and the element should fully contain the image.</p>

<p>Simple <code>:hover</code> and <code>:focus</code> states are then set for each button that alters the opacity of the button:</p>

<pre class="brush: css">.controls button:hover, .controls button:focus {
   opacity:0.5;
}</pre>

<p>To obtain appropriate button images, a set of free common control set icons was downloaded from the web. Each image was then converted to a base64 encoded string (using an online <a href="http://www.base64-image.de/">base64 image encoder</a>), since the images are quite small, the resultant encoded strings are quite short.</p>

<p>Since some buttons have dual functionality, e.g. play/pause, and mute/unmute, these buttons have different states that need to be styled. As mentioned earlier, a `data-state` variable is used to indicate which state such buttons are currently in.</p>

<p>For example, the play/pause button has the following background image definitions (the full base64 strings have been omitted for brevity):</p>

<pre class="brush: css">.controls button[data-state="play"] {
   background-image: url('data:image/png;base64,iVBORw0KGgoAAA ... ');
}

.controls button[data-state="pause"] {
   background-image: url('data:image/png;base64,iVBORw0KGgoAAA ... ');
}</pre>

<p>When the <code>data-state</code> of the button is changed, the appropriate image will also be changed. All the other buttons are treated in a similar way.</p>

<h3 id="Progress_bar">Progress bar</h3>

<p>The {{htmlelement("progress") }} element has the following basic style set up:</p>

<pre>.controls progress {
   display:block;
   width:100%;
   height:81%;
   margin-top:0.125rem;
   border:none;
   color:#0095dd;
   -moz-border-radius:2px;
   -webkit-border-radius:2px;
   border-radius:2px;
}</pre>

<p>Like the {{htmlelement("button") }} elements, {{htmlelement("progress") }} also has a default border, which is removed here. It is also given a slight rounded corner for aesthetic reasons. The <code>color</code> property is also defined here as Internet Explorer uses this defined colour for styling the progress bar's background colour as it increases.<br>
 <br>
 As mentioned in the <a href="https://developer.mozilla.org/en-US/Apps/Build/Manipulating_media/cross_browser_video_player">previous article</a>, there is a fallback provided for browsers that do not support the {{htmlelement("progress") }} element; this also needs to be styled appropriately:</p>

<pre class="brush: css">.controls progress[data-state="fake"] {
   background:#e6e6e6;
   height:65%;
}
.controls progress span {
   width:0%;
   height:100%;
   display:inline-block;
   background-color:#2a84cd;
}</pre>

<p>A <code>.data-state</code> class is also used here when a {{ htmlelement("progress") }} element is being "faked";  when it's in this state the background colour needs to be set. The internal {{htmlelement("span") }} element used as the actual progressing part of the faked progress bar has its width initially set to 0% (it is updated via JavaScript) and it also has its background colour set.</p>

<p>There are some browser-specific properties that need to be set to ensure that Firefox and Chrome use the required colour for the progress bar:</p>

<pre class="brush: css">.controls progress::-moz-progress-bar {
   background-color:#0095dd;
}

.controls progress::-webkit-progress-value {
   background-color:#0095dd;
}</pre>

<p>Although the same properties are set to the same value, these rules need to be defined separately, otherwise Chrome ignores it.</p>

<h2 id="JavaScript_2">JavaScript</h2>

<p>That's really it for the immediate styling; the next task is making a number of JavaScript changes to ensure that everything works as expected.</p>

<h3 id="Control_visibility">Control visibility</h3>

<p>The first change is simple: the <code>data-state</code> for showing the video controls when JavaScript is available to the browser now needs to be set:</p>

<pre class="brush: js">// Display the user defined video controls
videoControls.setAttribute('data-state', 'visible');</pre>

<h3 id="Progress_bar_support">Progress bar support</h3>

<p>A check also needs to be made to set up the "fake" progress bar if the browser doesn't support the {{htmlelement("progress") }} element:</p>

<pre class="brush: js">var supportsProgress = (document.createElement('progress').max !== undefined);
if (!supportsProgress) progress.setAttribute('data-state', 'fake');</pre>

<h3 id="Button_functionality">Button functionality</h3>

<p>This section looks at the JavaScript required for implementing the button functionality.</p>

<h4 id="PlayPause_and_Mute">Play/Pause and Mute</h4>

<p>Now that the buttons actually look like buttons and have images that indicate what they do, some changes need to be made so that the "dual functionality" buttons (such as the play/pause button) are in the correct "state" and display the correct image. In order to facilitate this, a new function is defined called <code>changeButtonState()</code>, which accepts a type variable indicating the button's functionality:</p>

<pre class="brush: js">var changeButtonState = function(type) {
   // Play/Pause button
   if (type == 'playpause') {
      if (video.paused || video.ended) {
         playpause.setAttribute('data-state', 'play');
      }
      else {
         playpause.setAttribute('data-state', 'pause');
      }
   }
   // Mute button
   else if (type == 'mute') {
      mute.setAttribute('data-state', video.muted ? 'unmute' : 'mute');
   }
}</pre>

<p>This function is then called by the relevant event handlers:</p>

<pre class="brush: js">video.addEventListener('play', function() {
   changeButtonState('playpause');
}, false);
video.addEventListener('pause', function() {
   changeButtonState('playpause');
}, false);
stop.addEventListener('click', function(e) {
   video.pause();
   video.currentTime = 0;
   progress.value = 0;
   // Update the play/pause button's 'data-state' which allows the correct button image to be set via CSS
   changeButtonState('playpause');
});
mute.addEventListener('click', function(e) {
   video.muted = !video.muted;
   changeButtonState('mute');
});</pre>

<p>You might have noticed that there are new handlers where the <code>play</code> and <code>pause</code> events are reacted to on the video. There is a reason for this! Even though the browser's default video control set has been turned off, many browsers make them accessible by right clicking on the HTML5 video. This means that a user could play/pause the video from these controls, which would then leave the custom control set's buttons out of sync. If a user uses the default controls, the defined Media API events — such as <code>play</code> and <code>pause</code> — are raised so this can be taken advantage of to ensure that the custom control buttons are kept in sync. To ensure this, a new click handler needs to be defined for the play/pause button so that it too raises the <code>play</code> and <code>pause</code> events:</p>

<pre class="brush: js">playpause.addEventListener('click', function(e) {
   if (video.paused || video.ended) video.play();
   else video.pause();
});</pre>

<h4 id="Volume">Volume</h4>

<p>The <code>alterVolume()</code> function, called when the player's volume buttons are clicked, also changes — it now calls a new function called <code>checkVolume()</code>:</p>

<pre class="brush: js">var checkVolume = function(dir) {
   if (dir) {
      var currentVolume = Math.floor(video.volume * 10) / 10;
      if (dir === '+') {
         if (currentVolume &lt; 1) video.volume += 0.1;
      }
      else if (dir === '-') {
         if (currentVolume &gt; 0) video.volume -= 0.1;
      }
      // If the volume has been turned off, also set it as muted
      // Note: can only do this with the custom control set as when the 'volumechange' event is raised, there is no way to know if it was via a volume or a mute change
      if (currentVolume &lt;= 0) video.muted = true;
      else video.muted = false;
   }
   changeButtonState('mute');
}
var alterVolume = function(dir) {
   checkVolume(dir);
}</pre>

<p>This new <code>checkVolume()</code> function does the same thing as the <code>alterVolume()</code> but it also sets the state of the mute button depending on the video's current volume setting. <code>checkVolume()</code> is also called when the <code>volumechange</code> event is raised:</p>

<pre class="brush: js">video.addEventListener('volumechange', function() {
   checkVolume();
}, false);</pre>

<h4 id="Progress_bar_2">Progress bar</h4>

<p>A small change also needs to be made to the click handler for the {{ htmlelement("progress") }} element. Since the enclosing {{htmlelement("figure") }} element now has <code>position:relative</code> set on it, the calculations made by this click handler are incorrect. It now also needs to take into account the offset position of the parent element:</p>

<pre class="brush: js">progress.addEventListener('click', function(e) {
   var pos = (e.pageX  - (this.offsetLeft + this.offsetParent.offsetLeft)) / this.offsetWidth;
   video.currentTime = pos * video.duration;
});</pre>

<h4 id="Fullscreen">Fullscreen</h4>

<p>The <a href="/en-US/Apps/Build/Manipulating_media/cross_browser_video_player#Fullscreen">FullScreen implemention</a> hasn't changed.</p>

<h2 id="Responsive_styling">Responsive styling</h2>

<p>Now that the player has its basic look and feel taken care of, some other styling changes — involving media queries — need to be made in order to make it responsive.</p>

<p>The player currently works fairly well until displayed on a "medium" screen (e.g. 1024px/64em) or smaller. In this case, the margins and padding on the {{ htmlelement("figure") }} element need to be removed so that all the available space is taken advantage of, and the buttons are a bit too small so this needs to be altered by setting a new height on the element that has the <code>.controls</code> class set on it:</p>

<pre class="brush: css">@media screen and (max-width:64em) {
   figure {
      padding-left:0;
      padding-right:0;
      height:auto;
   }

   .controls {
      height:1.876rem;
   }
}</pre>

<p>This works well enough until it is viewed on a smaller screen (680px/42.5em), so another breakpoint is made here. Since the height of the <code>.controls</code> class element will now vary, a fixed height is no longer required — it is therefore set to <code>auto</code>. The definitions for the elements within the .controls element now also need to changed:</p>

<pre class="brush: css">@media screen and (max-width:42.5em) {
   .controls {
      height:auto;
   }

   .controls &gt; * {
      display:block;
      width:16.6667%;
      margin-left:0;
      height:2.5rem;
      margin-top:2.5rem;
   }

   .controls .progress {
      position:absolute;
      top:0;
      width:100%;
      float:none;
      margin-top:0;
   }

   .controls .progress progress {
      width:98%;
      margin:0 auto;
   }

   .controls button {
      background-position:center center;
   }
}</pre>

<p>The <code>.progress</code> container is now moved to the top of the control set via <code>position:absolute</code>, so it and all the buttons need to be wider. In addition, the buttons need to be pushed below the progress container so that they are visible.</p>
